import qt
import qtext
import locale

locale.setlocale(locale.LC_ALL, "")
class MyScint(qtext.QextScintilla):
    def __init__(self):
        qtext.QextScintilla.__init__(self)

    def printstate(self, state):
        masks = {
            "Shift": qt.Qt.ShiftButton,
            "Ctrl": qt.Qt.ControlButton,
            "Alt": qt.Qt.AltButton,
            "Meta": qt.Qt.MetaButton }
        for name, mask in masks.iteritems():
            if state & mask:
                print name

    def keyPressEvent(self, e):
        print e.key()
        self.printstate(e.state())
        if e.state() == qt.Qt.AltButton | qt.Qt.ControlButton:
            newevent = qt.QKeyEvent(qt.QEvent.KeyPress,
                                    e.key(),
                                    e.ascii(),
                                    qt.Qt.MetaButton,
                                    e.text())
            print "change!"
            e = newevent
            self.printstate(e.state())

        qtext.QextScintilla.keyPressEvent(self, e)

    
app = qt.QApplication([""])


scint = MyScint()
app.setMainWidget(scint)
scint.show()
#print dir(scint)
app.exec_loop()

